{{ www.crustcrawler.com
 Dynamixel Bus Demo
  File....... DynaBus
  Purpose.... Dynamixel Bus Demo
  Author..... CrustCrawler Inc. (Mike Gebhard)
  Support.... http://forum.crustcrawler.com/phpBB3
  Started.... 5/4/2008
  Updated.... 5/4/2008
  Version.... Beta 0.37
  modified by Dave Ratcliff 6/3/09
}}
CON
        _clkmode        = xtal1 + pll16x
        _xinfreq        = 5_000_000

        'Instruction enumeration
        #1, i_Ping, i_ReadData, i_WriteData, i_RegWrite, i_Action, i_Reset, #131, i_SyncWrite         
        led = 2
        dyn = 0
VAR

  byte  byteArray[50]
  long bd,bd1,code
OBJ

  dy : "DynamixelAsmBus_v0.37_04272008"
  tv : "vga_text"
  kb : "keyboard"
   
PUB Start | a,i,x,y,speed
    
  tv.Start(16)                                             
  dy.Start(dyn, 1_000_000)
  kb.start(26,27)                                   
  dira[led]~~
  speed := 1                   'set servo move speed slow
  x := 512                     'center servo's
  y := 512
  
  word[@bytearray[0]] := x     
  repeat i from 1 to 4         'move servo #'s 1 to 4 
    writedata(i,30,2)
     
  repeat
    a := kb.getkey
    if a == 48                 'if "0" pressed set speed slow  
      speed := 1            
    if a == 49                 'if "1" pressed set speed medium 
      speed := 10        
    if a == 50                 'if "2" pressed set speed fast
      speed := 20        
    if a == 192                'left arrow
      x := x + speed     
    if a == 193                'right arrow
      x := x - speed           
    if a == 194                'up arrow
      y := y + speed   
    if a == 195                'down arrow
      y := y - speed   
        
    x := 260 #> x <# 1023      'x limits - set low and high servo position limits    
    y := 220 #> y <# 620       'y limits    

    word[@bytearray[0]] := x   'move arm to x position
    writedata(1,30,2)
    word[@bytearray[0]] := y   'move arm to y position
    writedata(2,30,2)        
        
    tv.out(1)                  'display x,y values 
    tv.dec(x)
    tv.str(string("     ",13)) 
    tv.dec(y)
    tv.str(string("     ",13)) 
       
PUB Ping(id) | mode, pl, cs, len
{{Ping(<id>}}
  len := $02
  cs := (id + len + i_Ping)^$FF
  dy.SetAxBuffer(0, $FF)
  dy.SetAxBuffer(1, $FF)
  dy.SetAxBuffer(2, id)
  dy.SetAxBuffer(3, len)
  dy.SetAxBuffer(4, i_Ping)
  dy.SetAxBuffer(5, cs)

  pl := len + $04
  mode := GetResponseMode(i_Ping)
  
  'Execute
  dy.ExecuteCommand(pl,mode)
  IsException
  SendResponseToDebug

PUB ReadData(id, startAddr, bytesToRead) | len, cs, pl, mode
{{ReadData(<id>, <start address>, <number of bytes to read>)}}
    
  len := $04
  cs := (id + len + i_ReadData + startAddr + bytesToRead)^$FF
    
  dy.SetAxBuffer(0, $FF)
  dy.SetAxBuffer(1, $FF)
  dy.SetAxBuffer(2, id)
  dy.SetAxBuffer(3, len)
  dy.SetAxBuffer(4, i_ReadData)
  dy.SetAxBuffer(5, startAddr)
  dy.SetAxBuffer(6, bytesToRead)
  dy.SetAxBuffer(7, cs)
  
  pl := len + $04
  mode := GetResponseMode(i_ReadData)
  
  'Execute
  dy.ExecuteCommand(pl, mode)
  IsException
  'SendResponseToDebug
  
PUB WriteData(id, startAddr, N) | len, pl, cs, mode, tempSum, idx, idx2
{{WriteData(<id>, <start address>, <number of bytes to write>)}} 
  'N+3 because you need to add the start address parameter
  len := N + 3
  idx := 0
  idx2 := 0
  tempSum := 0
  
  dy.SetAxBuffer(idx++, $FF)
  dy.SetAxBuffer(idx++, $FF)
  dy.SetAxBuffer(idx++, id)
  dy.SetAxBuffer(idx++, len)
  dy.SetAxBuffer(idx++, i_WriteData)
  dy.SetAxBuffer(idx++, startAddr)
  'get all data bytes to send
  repeat N
    tempSum += byteArray[idx2]
    dy.SetAxBuffer((idx), byteArray[idx2])
    idx++
    idx2++
    
  'CheckSum  
  cs := (id + len + i_WriteData + startAddr + tempSum)^$FF
  'Set checksum
  dy.SetAxBuffer((idx), cs)

  'Packet length and mode
  pl := len + $04
  mode := GetResponseMode(i_WriteData)
  
  'Execute
  dy.ExecuteCommand(pl, mode)
  IsException
  SendResponseToDebug
 

PUB RegWrite(id, startAddr, N)  | len, pl, cs, mode, tempSum, idx, idx2
{{
  RegWrite(<id>, <start address>, <number of bytes to write>)
  You must execute the Action command after the RegWrite command
}}
  'N+3 because you need to add the start address parameter
  len := N + 3
  idx := 0
  idx2 := 0
  tempSum := 0
  
  dy.SetAxBuffer(idx++, $FF)
  dy.SetAxBuffer(idx++, $FF)
  dy.SetAxBuffer(idx++, id)
  dy.SetAxBuffer(idx++, len)
  dy.SetAxBuffer(idx++, i_RegWrite)
  dy.SetAxBuffer(idx++, startAddr)
  'get all data bytes to send
  repeat N
    tempSum += byteArray[idx2]
    dy.SetAxBuffer((idx), byteArray[idx2])
    idx++
    idx2++
    
  'CheckSum  
  cs := (id + len + i_RegWrite + startAddr + tempSum)^$FF
  'Set checksum
  dy.SetAxBuffer((idx), cs)

  'Packet length and mode
  pl := len + $04
  mode := GetResponseMode(i_RegWrite)
  
  'Execute
  dy.ExecuteCommand(pl, mode)
  IsException
  

PUB Action | mode, pl, cs, len, id
  len := $02
  id := $FE
  cs := (id + len + i_Action)^$FF
  
  dy.SetAxBuffer(0, $FF)
  dy.SetAxBuffer(1, $FF)
  dy.SetAxBuffer(2, id)
  dy.SetAxBuffer(3, len)
  dy.SetAxBuffer(4, i_Action)
  dy.SetAxBuffer(5, cs)

  pl := len + $04
  mode := GetResponseMode(i_Action)
  
  'Execute
  dy.ExecuteCommand(pl,mode)  
  IsException

  
PUB SyncWrite(numDynamixels, startAddr, numBytes) | pl, cs, mode, tempSum, idx, idx2, id, len
{{SyncWrite(<length>,<start address>,<number if dynamixles>, <data lenght>)
number of dynamixels, # of bytes to write, starting address, data[]     }}
  idx := 0
  idx2 := 0
  tempSum := 0
  id := $FE
  len := ((numBytes + 1) * numDynamixels)
  
  dy.SetAxBuffer(idx++, $FF)
  dy.SetAxBuffer(idx++, $FF)
  dy.SetAxBuffer(idx++, id)
  'Half of the length equations was done above 
  dy.SetAxBuffer(idx++, len + 4)
  dy.SetAxBuffer(idx++, i_SyncWrite)
  dy.SetAxBuffer(idx++, startAddr)
  dy.SetAxBuffer(idx++, numBytes)
  'get all data bytes to send
  repeat len
    tempSum += byteArray[idx2]
    dy.SetAxBuffer((idx++), byteArray[idx2++])

  'CheckSum  
  cs := (id + (len + 4) + numBytes + i_SyncWrite + startAddr + tempSum)^$FF
  
  'Set checksum
  dy.SetAxBuffer((idx), cs)

  'Packet length and mode
  pl := len + 4 + 4
  
  mode := GetResponseMode(i_RegWrite)
  
  'Execute
  dy.ExecuteCommand(pl, mode)
  IsException
  
  
PUB Reset(id) | mode, pl, cs, len
  len := $02
  cs := (id + len + i_Reset)^$FF
  dy.SetAxBuffer(0, $FF)
  dy.SetAxBuffer(1, $FF)
  dy.SetAxBuffer(2, id)
  dy.SetAxBuffer(3, len)
  dy.SetAxBuffer(4, i_Reset)
  dy.SetAxBuffer(5, cs)

  pl := len + $04
  mode := GetResponseMode(i_Reset)
  
  'Execute
  dy.ExecuteCommand(pl,mode)
  IsException
  SendResponseToDebug
  

PRI GetResponseMode(instructionType) : mode
  case instructionType
    I_Ping          : mode := 1
    I_ReadData      : mode := 1
    I_WriteData     : mode := 1
    I_RegWrite      : mode := 2
    I_Action        : mode := 2
    I_Reset         : mode := 1
    I_SyncWrite     : mode := 2
    other           : mode := 0
   
PRI SendResponseToDebug | pl, idx
{{Output to VGA screen
  pl :=  dy.GetAxBuffer($03) + 3
  repeat idx from 0 to pl 
    tv.hex(dy.GetAxBuffer(idx),2)
    tv.str(string(" "))
  tv.out(13)}}
  
PRI RestartDynaBus
{{If all else fails hit the engineer switch to restart the DynaBus cog}}
  dy.Stop
  dy.Start(2, 1_000_000)
  
PRI IsException
{{Visual indicator
  Demo board LED 23 blinks after Tx operation
  A timeout causes LEDs 23, 22, then 21 to blink
  An offline situation causes LEDs 23, 22, 21 to blink
}}
    if dy.IsTimeout
      outa[led]~~
    elseif dy.IsBusoffline
      outa[led]~~
    else
      outa[led]~        